#include "tsbrowse4.h"
#pragma hdrstop
#include "tsb4_f_mnot.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TModuleNotifierForm *ModuleNotifierForm;
//---------------------------------------------------------------------------


typedef void __fastcall (__closure *TComponentRenamedEvent)(TObject *Sender,void*ptr,const AnsiString OldName,const AnsiString NewName);
typedef void __fastcall (__closure *TModuleNotifyEvent)(TObject *Sender,TNotifyCode n);

class TMyNot : public TIModuleNotifier
{
public:
  __fastcall TMyNot() {FOnComponentRenamed=NULL; FOnNotify=NULL;}
  void __stdcall ComponentRenamed(void *ComponentHandle,const AnsiString OldName,const AnsiString NewName)
  { if (FOnComponentRenamed!=NULL) FOnComponentRenamed(this,ComponentHandle,OldName,NewName);
  }
  void __stdcall Notify(TNotifyCode NotifyCode)
  { if (FOnNotify!=NULL) FOnNotify(this,NotifyCode);
  }
  __property TComponentRenamedEvent OnComponentRenamed = {read=FOnComponentRenamed,write=FOnComponentRenamed};
  __property TModuleNotifyEvent OnNotify = {read=FOnNotify,write=FOnNotify};
protected:
  TComponentRenamedEvent FOnComponentRenamed;
  TModuleNotifyEvent FOnNotify;
};



__fastcall TModuleNotifierForm::TModuleNotifierForm(TComponent* Owner)
        : TForm(Owner)
{ mi=NULL; mn=NULL;
}
//---------------------------------------------------------------------------
void __fastcall TModuleNotifierForm::Initialise(AnsiString s,TIModuleInterface *ami)
{ mi=ami;
  mi->AddRef();
  TMyNot *mymn=new TMyNot();
  mymn->OnComponentRenamed=MyNotComponentRenamed;
  mymn->OnNotify=MyNotNotify;
  mn=mymn; mi->AddNotifier(mn);
  Caption=s;
}

void __fastcall TModuleNotifierForm::MyNotComponentRenamed(TObject *Sender,void *ptr,const AnsiString OldName,const AnsiString NewName)
{ if (GetAsyncKeyState(VK_SHIFT)<0) return;
  AnsiString s="rename: "+OldName+" --> "+NewName;
  Log->Lines->Add(s);
}
void __fastcall TModuleNotifierForm::MyNotNotify(TObject *Sender,TNotifyCode n)
{ if (n==ncModuleDeleted) Stop();
  AnsiString s="unknown code";
  AnsiString t="notify: ";
  switch (n)
  { case ncAfterSave: s="ncAfterSave"; break;
    case ncBeforeSave: s="ncBeforeSave"; break;
    case ncEditorModified: s="ncEditorModified"; break;
    case ncEditorSelected: s="ncEditorSelected"; break;
    case ncFormModified: s="ncFormModifed"; break;
    case ncFormSaving: s="ncFormSaving"; break;
    case ncFormSelected: s="ncFormSelected"; break;
    case ncModuleDeleted: s="ncModuleDeleted"; break;
    case ncModuleRenamed: s="ncModuleRenamed"; break;
    case ncProjResModified: s="ncProjResModified"; break;
  }
  Log->Lines->Add(t+s);
  if (n==ncModuleDeleted) Close();
}

void __fastcall TModuleNotifierForm::Stop()
{ mi->RemoveNotifier(mn);
  mi->Release();
  delete mn; mn=NULL;
}

void __fastcall TModuleNotifierForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{ Action=caFree;
  if (mn!=NULL) Stop();
}
//---------------------------------------------------------------------------
void __fastcall TModuleNotifierForm::btnRemoveNotifierClick(
      TObject *Sender)
{ Close();
}
//---------------------------------------------------------------------------

void __fastcall TModuleNotifierForm::btnClearLogClick(TObject *Sender)
{ Log->Clear();

}
//---------------------------------------------------------------------------

